=== doc/talk/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 

set(outdir ${CMAKE_BINARY_DIR}/doc/html/talk)
file(MAKE_DIRECTORY ${outdir})

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/talk.html
  COMMAND rsync -va ${CMAKE_CURRENT_SOURCE_DIR}/ui/ ${outdir}/ui/
  COMMAND cp ${ecto_SOURCE_DIR}/kitchen/doc/source/art/* ${outdir}
  COMMAND rst2s5 --theme-url=ui/ecto ${CMAKE_CURRENT_SOURCE_DIR}/talk.rst ${outdir}/talk.html
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  
add_custom_target(talk-html DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/talk.html)
