=== debian/control ===
Source: ros-lunar-ecto
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, python-dev, ros-lunar-catkin
Homepage: http://plasmodic.github.io/ecto/
Standards-Version: 3.9.2

Package: ros-lunar-ecto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, python-dev, xdot
Description: Ecto is a hybrid C++/Python development framework for constructing and maintaining pipelines.
